#!/usr/bin/python2
# -*- coding: utf-8 -*-
import os
import glob
import requests
import re
from lxml import etree

kanji = u'[㐀-䶵一-鿋豈-頻]'


def html(e):
    #print(etree.tostring(artice, pretty_print=True))
    return etree.tostring(e, encoding='UTF-8', method='html')

def rm(e):
    e.getparent().remove(e)

def dl(url):
    if url.startswith('https://kanjiportraits.files.wordpress.com'):
        local = url[8:]
        local = 'files' + url[42:]
        if not os.path.isfile(local):
            os.spawnlp(os.P_WAIT, 'wget', 'wget','-m', '-np', url)
        return local

def convertposts(post):
    out=[]
    d={}
    for i in post:
        #print i
        doc = etree.HTML(open(i,'r').read())
        article = doc.xpath('//article')[0]
        article.attrib.pop('class',None)

        for bad in article.xpath("//div[@id='jp-post-flair']"):
            bad.getparent().remove(bad)

        for bad in article.xpath("//a[contains(@class,'entry-format-badge')]"):
            rm(bad)

        for bad in article.xpath("//span[contains(@class,'entry-format-badge')]"):
            rm(bad)

        for bad in article.xpath("//li[contains(@class,'comment-meta')]"):
            rm(bad)

        for img in article.xpath("//img[contains(@src,'kanjiportraits.files.wordpress.com')]"):
            att = img.attrib
            att.pop('data-attachment-id',None)
            att.pop('data-permalink',None)
            att.pop('data-comments-opened',None)
            att.pop('data-image-meta',None)
            att.pop('data-medium-file',None)
            att.pop('data-large-file',None)
            att.pop('srcset',None)
            if not att.get('data-image-description'):
                att.pop('data-image-description',None)
            if 'data-orig-file' in att:
                orig = att.pop('data-orig-file')
                src = dl(orig)
                att['src'] = src

        for img in article.xpath("//source[contains(@src,'kanjiportraits.files.wordpress.com')]"):
            att = img.attrib
            src = att['src']
            src = src.split('?')[0]
            att['src'] = dl(src)

        for img in article.xpath("//a[contains(@href,'kanjiportraits.files.wordpress.com')]"):
            att = img.attrib
            att['href'] = dl(att['href'])

        for iframe in article.xpath("//iframe[contains(@src,'youtube')]"):
            att = iframe.attrib
            src = att["src"]
            new=etree.Element('a')
            new.attrib['href'] = src
            new.text= src
            iframe.getparent().append(new)
            rm(iframe)

        mo = re.search(r'/(20\d\d/\d\d/\d\d)',i)
        if mo:

            for h1 in article.xpath("//h1[contains(@class,'entry-title')]"):
                index = h1.text
                mo2 = re.findall(kanji, index)
                for k in mo2:
                    l = d.setdefault(k,[])
                    post = article.attrib['id']
                    if post not in l:
                        l.append(article.attrib['id'])
                date = mo.group(1).replace('/','-')
                h1.text = date + ' ' + h1.text

        for meta in article.xpath("//div[contains(@class,'meta-text')]"):
            etree.strip_tags(meta, 'a')
        post = html(article).decode('utf-8')
        out.append(post)
    return out, d


post = glob.glob('kanjiportraits.wordpress.com/2*/*/*/*/index.html')
post.sort()
post += glob.glob('kanjiportraits.wordpress.com/about-*/index.html')
post += glob.glob('kanjiportraits.wordpress.com/refere*/index.html')

out,d = convertposts(post)

result = u'''<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8"/>
<meta name="viewport" content="width=device-width, initial-scale=1">
<style>
body {
    background: #fafafa;
    color: #222;
    font-family: "HelveticaNeue", "Helvetica Neue", Helvetica, Arial, sans-serif;
    font-size: 15px;
    line-height: 1.5;
}
@media screen and (min-width: 800px) {
    body {
        margin: 30px 45px;
    }
}
article {
    clear: both;
    padding-bottom: 30px;
    border-bottom: 1px solid #222;
    margin-bottom: 30px;
    max-width: 800px;
    margin-left: auto;
    margin-right: auto;
}
h1, h2, h3, h4, h5, h6 {
    clear: both;
    margin: 0 0 20px;
}
img {
    height: auto;
    max-width: 100%;
}
.alignleft {
    display: inline;
    float: left;
    margin-right: 20px;
}
.alignright {
    display: inline;
    float: right;
    margin-left: 20px;
}
.aligncenter {
    clear: both;
    display: block;
    margin: 0 auto;
}
.wp-caption {
    margin-bottom: 20px;
    max-width: 100%;
    border: none;
}
.wp-caption-text {
    padding: 5px 10px;
    background: #e5e5e5;
    font-size: 12px;
    line-height: 1.5;
    text-align: center;
}
.index {
    text-decoration: none;
}
</style>
<title>Kanji Portraits</title>
</head>
<body>
<article>
    <h1>Kanji Portraits mirror</h1>
    <p>
    This a mirror of the <a href="https://kanjiportraits.wordpress.com/">Kanji Portraits</a> blog by <a href="#post-176">Noriko K. Williams</a> written between 2013 and 2018 about the etymology of kanjis.
    An offline copy is available as zip file <a href="kanjiportraits.zip">kanjiportraits.zip</a> (55 MB).
    </p>
    <h1>Index</h1>
'''

kanjis = d.keys()
kanjis.sort()
for k in kanjis:
    result += u'<a href="#%s" class="index">%s</a> ' % (d[k][0], k)
    for add in enumerate(d[k][1:]):
        #result += u'<a href="#%s" class="index">%s</a> ' % (add[1], "(%d)"% (add[0]+2))
        result += u'<a href="#%s" class="index">%s</a> ' % (add[1], k)
        


result += u'''
</article>
'''

result += u"\n\n".join(out)


open("kanjiportraits.html","wb").write(result.encode('utf8'))

os.spawnlp(os.P_WAIT, 'zip', 'zip', '-r', 'kanjiportraits', 'kanjiportraits.html', 'mirror.sh', 'process.py', 'files')
